//+------------------------------------------------------------------+
//|                                                              rsx |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed

//
//
//
//
//

extern int    Length       = 14;
extern int    Price        = PRICE_TYPICAL;
extern int    Depth        = 3;
extern double Speed        = 0.5;
extern bool   ColorOnSlope = false;

//
//
//
//
//

double rsx[];
double rsxHuu[];
double rsxHud[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,rsxHuu); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1,rsxHud); SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2,rsx);
      SetIndexBuffer(3,slope);
         Speed = MathMax(MathMin(1.5,Speed),0.1);
         Depth = MathMax(MathMin(10 ,Depth),1);
         IndicatorShortName("Rsx ("+Length+","+Depth+","+DoubleToStr(Speed,2)+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkBuffer[][41];

int start()
{
   int i,r,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+Length); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][0] = iMA(NULL,0,1,0,MODE_SMA,Price,i);

         if (i==(Bars-1)) { for (int c=1; c<13; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][0]-wrkBuffer[r-1][0];
      double moa = MathAbs(mom);
      for (int k=0; k<Depth; k++)
      {
         int kk = k*4;
            wrkBuffer[r][kk+1] = Kg*mom                + Hg*wrkBuffer[r-1][kk+1];
            wrkBuffer[r][kk+2] = Kg*wrkBuffer[r][kk+1] + Hg*wrkBuffer[r-1][kk+2]; mom =         1.5*wrkBuffer[r][kk+1] - Speed * wrkBuffer[r][kk+2];
            wrkBuffer[r][kk+3] = Kg*moa                + Hg*wrkBuffer[r-1][kk+3];
            wrkBuffer[r][kk+4] = Kg*wrkBuffer[r][kk+3] + Hg*wrkBuffer[r-1][kk+4]; moa = MathAbs(1.5*wrkBuffer[r][kk+3] - Speed * wrkBuffer[r][kk+4]);
      }
      if (moa != 0)
           rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)-50.0; 
      else rsx[i] = 0;
      
      //
      //
      //
      //
      //
      
      rsxHuu[i] = EMPTY_VALUE;
      rsxHud[i] = EMPTY_VALUE;
      slope[i]  = slope[i+1];
         if (rsx[i]>rsx[i+1]) slope[i] =  1;
         if (rsx[i]<rsx[i+1]) slope[i] = -1;
         if (ColorOnSlope)
         {
            if (slope[i]== 1) { rsxHuu[i] = High[i]; rsxHud[i] = Low[i]; }
            if (slope[i]==-1) { rsxHud[i] = High[i]; rsxHuu[i] = Low[i]; }
         }
         else
         {
            if (rsx[i]>0) { rsxHuu[i] = High[i]; rsxHud[i] = Low[i]; }
            if (rsx[i]<0) { rsxHud[i] = High[i]; rsxHuu[i] = Low[i]; }
         }
   }
   return(0);
}